## sather-1.2.3.tar.gz

=== Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 1994 by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 3 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Be sure to read the file Doc/Installation!
# You may need to set some variables in System/Common/CONFIG.proto
# to be appropriate to your system.
# Also make sure to adjust the paths in System/Platforms/X/Platform.module
# and System/Platforms/tcltk/Platform.module

export SATHER_HOME=$(shell pwd)

############################## VARIABLES TO SET ###############################

# Standard things
# CMP=cmp
RANLIB=ranlib
MV=mv
AR=ar
RM=rm -f
LN=ln -sf
CP=cp

CPP=/lib/cpp -C -P
CC=gcc
EXEC_SUFFIX=
# CC is only used for bootstrapping, check System/Common/CONFIG.proto if
# you want to change it for all Sather compilations

# Changes for Alpha
#CPP=/usr/ucb/cpp -C -P -DALPHA
#CC=gcc -DALPHA
#GC_CC=cc

# Changes for Win32
#CPP=gcc -E -C -P
#EXEC_SUFFIX=.exe

# The name of the produced binaries
SACOMP      =Bin/sacomp$(EXEC_SUFFIX)
SACOMP-BOOT =Boot/sacomp$(EXEC_SUFFIX)    # This has to be changed lateron
SABROWSE    =Bin/sabrowse$(EXEC_SUFFIX)

CS_OPT        =-verbose -O_fast -O_no_move_while -O_no_hoist_const -O_no_cse -only_reachable
CS_OPT_DEBUG  =-verbose -chk -C_flag -O -debug -debug_deterministic -debug_no_backtrace
CS_OPT_PROFILE=-verbose -only_reachable -optimize -C_flag -pg


# The list of platforms to install, in addition to "BOOT".
# "BOOT" intended to be the least common denominator required
# across all present and future platforms.  At the moment it
# uses the Boehm collector.
# This needs to edited to match the system. PLATFORMS is a comma
# separated list.
# If you intend to use threads, specify the matching parallel
# platform.

#PLATFORMS=linux,linux/lwp,linux_at,linux_at/smp
PLATFORMS=linux
#	  solaris,			\
#	  solaris_at/sparc_smp,		\
#	  solaris_at/sparc_myrinet,	\
#	  solaris/sparc_smp,		\
#	  solaris/sparc_myrinet,	\
#	  solaris/sparc_tcpip,		\
#	  solaris_at/i386_smp,		\
#	  hpux_at/hppa_smp,		\
#	  osf_at/axp_smp,		\
#	  unix,				\
#	  linux,			\
#	  linux/lwp,			\
#	  linux_at,			\
#	  linux_at/smp,			\
#	  iris-4,			\
#	  freebsd,			\
#	  win32,			\
#	  win32_at,			\
#	  win32_at/i386_smp,		\
#	  win32_at/i386_tcpip,		\


# The platform to use if not overridden by a -<platform> option
# or the SATHER_PLATFORM environment variable
# Should be edited for a particular system
DEFAULT_PLATFORM=linux

# The platform used to compile the boot compiler. Usually just default, but has to
# be one of: freebsd, hpux_at, iris-4, linux, osf_at, solaris, solaris_at, unix,
#            win32, win32_at
BOOT_PLATFORM=$(DEFAULT_PLATFORM)


################################ DEPENDENCIES #################################

# Make the boot compiler, compile the compiler with the boot compiler
# and install this new compiler. You need at least 60MB virtual memory
# for this. See Doc/Installation for details.
full: compiler


# Compile the boot compiler and use it as the compiler. This should
# work on most systems and does not require you to recompile the
# compiler itself. This is the default installation target.
small: bootcompiler
	${LN} ../$(SACOMP-BOOT) $(SACOMP)
	@echo; echo "...Boot compiler is now installation compiler." ; echo


# The compiler which ends up in Bin/ is the "fast" executable,
# which means that checking is turned off and optimizations are on.

# Some makes can't expand glob syntax with more than one *, so
# only specify one directory to expand instead of listing all of them.
# Watch out for this if you are modifying the compiler.

# This runs the C compiles after the Sather compiler instead of at
# the same time, to ease installation for those with small VM.

compiler: system bootcompiler
	@echo; echo "Creating C for installation compiler..." ; echo
	$(SACOMP-BOOT) $(CS_OPT) Compiler/sacomp.module -o $(SACOMP) -only_C
	@echo; echo "Compiling C for installation compiler..." ; echo
	$(MAKE) -C $(SACOMP).code

optional: bootcompiler
	@echo "*************************************************************"
	@echo "        Trying to compile the optional Browser and Gui"
	@echo "*************************************************************"
	@echo "This step compiles the browser and provides the"
	@echo "        -dualgui and -debug_graphical compiler options:"
	@echo "If this step fails, it may be restarted by calling"
	@echo "      make optional"
	@echo "Requirements: "
	@echo "     Tcl7.4 and Tk4.0 for the Browser and Gui"
	@echo "     Sockets for the -dualgui and the -debug_graphical option"
	@echo "See Doc/Installation.html for more details."
	@echo "For errors, check:"
	@echo "      System/Platforms/tcltk/Platform.module "
	@echo "      System/Platforms/X/Platform.module "
	@echo "Also check System/Platforms/tcltk/startup.tcl"
	@echo "*************************************************************"
	@echo
	$(MAKE) browser
	$(MAKE) dualgui

browser:
	@echo; echo "Creating C for Browser..." 
	$(SACOMP) $(CS_OPT) Browser/browser.module -main BROWSER -o $(SABROWSE) -only_C
	@echo; echo "Compiling C for Browser..."
	$(MAKE) -C $(SABROWSE).code

# The following step creates the server for the dual process gui.
# The standard gui/browser do not need this step. However, it is almost
# certain that any system problems affecting the dual gui server will
# also affect that the standard gui and browser.
dualgui:	
	@echo; echo Creating server end for two-process Gui...; 
	@echo "****************************************************"; 
	@echo "Installing the server for the Dual process Gui, -dualgui"
	@echo "Required for use of the"
	@echo "     -dualgui and -debug_graphical"
	@echo "compiler options"
	@echo "See the notes in Doc/Installation.html for more details."
	@echo "****************************************************";
	$(MAKE) -C System/Platforms/dualgui

debug: bootcompiler
	$(SACOMP-BOOT) $(CS_OPT_DEBUG) Compiler/sacomp.module -o $(SACOMP) -only_C
	$(MAKE) -C $(SACOMP).code

profile: 
	$(SACOMP-BOOT) $(CS_OPT_PROFILE) Compiler/sacomp.module -o $(SACOMP) -only_C
	$(MAKE) -C cd $(SACOMP).code

bootcompiler: system
	@echo; echo "Making boot compiler..." ; echo
	$(MAKE) -C System/Platforms/$(BOOT_PLATFORM) boot CC='$(CC)'


# The rule for System/Common/CONFIG also makes the serial libraries,
# as well as making any platforms.

system: common library platforms

common:
	@ CC="$(CC)" RANLIB="$(RANLIB)" CPP="$(CPP)"			\
	  MV="$(MV)" AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"	\
	  export CC GC_CC RANLIB CPP MV AR RM LN CP;			\
	DEFAULT_PLATFORM='$(DEFAULT_PLATFORM)' PLATFORMS='$(PLATFORMS)' \
	$(MAKE) -C System/Common

library:
	@echo; echo -n "Making serial library: "
	@cd pLibrary; ./PP

platforms:
	@ CC="$(CC)" RANLIB="$(RANLIB)" CPP="$(CPP)"			\
	  MV="$(MV)" AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"	\
	  export CC GC_CC RANLIB CPP MV AR RM LN CP;			\
	echo;								\
	for i in `echo "BOOT",$(PLATFORMS) | tr , \ `; do		\
	  echo "Making platform $$i..." ;				\
	  $(MAKE) -C System/Platforms/$$i ;				\
	done							

info:
	cd Emacs && makeinfo sather.texinfo
	cd Emacs && makeinfo sather-tutorial.texinfo
	cd Emacs && makeinfo sather-mode.texinfo


################################### TESTING ###################################

# There are two tests.  The first is the test classes in the library,
# which is pretty straightforward.  The second is a full 
# double compilation of the compiler, which can take quite a while.

test:
	$(MAKE) -C Test test

# The full test does the following:
#
#    1. Compile using Bin/sacomp, with full checking on.
#    2. Compile using result.

testfull:
	$(MAKE) -C Test test-full


################################### CLEANING ##################################

clean-unneeded:
	$(RM) -r $(SACOMP).code $(SABROWSE).code
	$(RM) $(SACOMP-BOOT) $(SACOMP-BOOT).code/*.o

clean: clean-unneeded
	$(MAKE) -C System/Common clean DEPEND=
	$(MAKE) -C System/pSather clean DEPEND=
	$(MAKE) -C Test clean DEPEND=
	 
	for i in System/Platforms/* ; do				\
	  if [ -f $$i/Makefile ] ; then $(MAKE) -C $$i clean ; fi	\
	done;
	
	$(RM) $(SACOMP) $(SABROWSE)
	
	$(RM) -r Doc/man/{whatis,cat1,windex}
	$(RM) Emacs/*.elc
	$(RM) Emacs/*.info Emacs/*.info??
	$(RM) Library/System/Socket/socket.sa
	$(RM) Library/Containers/stack.sa
	$(RM) Library/Containers/nr_stack.sa
	$(RM) Library/Containers/a_stack.sa
	$(RM) Library/Containers/nr_a_stack.sa
	$(RM) pLibrary/Containers/nr_stack.sa
	$(RM) pLibrary/Containers/nr_a_stack.sa
	
	debian/rules clean-safe

=== Test/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 3 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

SACOMP         =Bin/sacomp
CS_OPT         =-chk -verbose -output_C
CS_PSATHER_OPT =-linux/lwp

TESTCS1     =./test-cs-first
TESTCS2     =./test-cs-second
TESTALL     =./test-all
TESTFULL    =./test-full
TESTPSATHER =./test-psather

####################### TESTING ########################

test: test-all

# There are two tests.  The first is the test classes in the library,
# which is pretty straightforward.  The second is a full 
# double compilation of the compiler, which can take quite a while.

test-all:
	@echo; echo Testing...; echo
	../$(SACOMP) $(CS_OPT) test-all.module -main TEST_OBLIG -o $(TESTALL)
	$(TESTALL) > $(TESTALL).output

# The full test does the following:
#
#    1. Compile using Bin/sacomp, with full checking on.
#    2. Compile using result.
#    3. Clean up.

test-full:
	@echo; echo "Doing full test..." ; echo
	@echo; echo "Compiling 1st..." ; echo
	../$(SACOMP) $(CS_OPT) ../Compiler/sacomp.module -o $(TESTCS1)
	@echo; echo "Compiling 2nd..." ; echo
	$(TESTCS1) $(CS_OPT) ../Compiler/sacomp.module -o $(TESTCS2)
	
	$(TESTCS2) $(CS_OPT) test-all.module -o $(TESTFULL)
	$(TESTFULL) > $(TESTFULL).output
	
	@ CC="$(CC)" RANLIB="$(RANLIB)" CPP="$(CPP)" MV="$(MV)"	\
	  AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"		\
	  export CC RANLIB CPP MV AR RM LN CP;			\
	for i in `echo $(PLATFORMS) | tr , \ ` ; do		\
	  echo "Testing platform $$i..." ;			\
	  $(MAKE) -C ../System/Platforms/$$i test ;		\
	done
	
	@echo; echo "Everything okay" ; echo

test-psather:
	../$(SACOMP) $(CS_OPT) $(CS_PSATHER_OPT) test-psather.module -o $(TESTPSATHER)
	$(TESTPSATHER) > $(TESTPSATHER).output

clean:
	rm -fr $(TESTCS1) $(TESTCS1).code
	rm -fr $(TESTCS2) $(TESTCS2).code
	rm -fr $(TESTALL) $(TESTALL).code $(TESTALL).output
	rm -fr $(TESTFULL) $(TESTFULL).code $(TESTFULL).output
	rm -fr $(TESTPSATHER) $(TESTPSATHER).code $(TESTPSATHER).output

# These test rules are used at the ICSI. If you work on the compiler they
# may be useful for you too, but you will probably have to hack the perl
# scripts in Test and Test/TestPrg/PROG (they are adapted to the 
# specific way files and home directories are set up at ICSI).

testcommit: SYSTEM prepare_test 
	@ CC="$(CC)" RANLIB="$(RANLIB)" CPP="$(CPP)" MV="$(MV)"	\
	  AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"		\
	  export CC RANLIB CPP MV AR RM LN CP;			\
	for i in solaris					\
	         solaris/sparc_smp				\
		 solaris/sparc_tcpip				\
	         solaris_at/sparc_smp				\
		 solaris_at/sparc_myrinet; do			\
	  echo "Making platform $$i..." ;			\
	  $(MAKE) -C System/Platforms/$$i			\
	done
	
	./do_test solaris solaris/sparc_smp solaris/sparc_tcpip \
	          solaris_at/sparc_smp solaris_at/sparc_myrinet

testcomplete:
	./do_test `echo $(PLATFORMS) | tr '",' '  '`

testplatform:
	@ CC="$(CC)" RANLIB="$(RANLIB)" CPP="$(CPP)" MV="$(MV)"	\
	  AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"		\
	  export CC RANLIB CPP MV AR RM LN CP;			\
	$(MAKE) -C ../System/Platforms/$(PLATFORM)
	./do_test `echo $(PLATFORM)`

=== Boot/sacomp.code/Makefile ===
SHOME  =../..
CFLAGS = -I.  -O2  -I../System/Common
CC     =gcc 
HDR    =sather.h tags.h
LIBS   = -lgc -lm
CS     =sacomp
OBJ    = a_stackA_STACK2014955575.o am_outAM_OUT1363671444.o am_outAM_OUT1363671444x.o arefFSETAM_ROU1518004496.o arefFSETIMMUTA2116029667.o arefFSETTUPSIG268064465.o arrayARRAYAM_I1084914261.o arrayARRAYTUPI1927875024.o as_outAS_OUT1429002792.o as_outAS_OUT1429002792x.o cgenCGEN1354269066.o cgenCGEN1354269066x.o cgenCGEN1354269066xx.o cgenCGEN1354269066xxx.o cgenCGEN1354269066xxxx.o cgenCGEN1354269066xxxxx.o cgenCGEN1354269066xxxxxx.o cgenCGEN1354269066xxxxxxx.o cgenCGEN1354269066xxxxxxxx.o cgenCGEN1354269066xxxxxxxxx.o cgenCGEN1354269066xxxxxxxxxx.o code_fileCODE_372141741.o configCONFIG_R422014871.o cs_optionsCS_O301318552.o cs_optionsCS_O301318552x.o cursorAM_CURSO1314676474.o cursorAM_CURSO1314676474x.o cursorAM_CURSO1314676474xx.o cursorAM_CURSO1314676474xxx.o dispatch.o eltELT742463773.o elt_algELT_ALG1548486913.o elt_algELT_ALG241706736.o elt_algELT_ALG433952755.o elt_algELT_ALG656599769.o elt_algELT_ALG987448979.o flistFLISTAM_C1171004157.o flistFLISTTUPA253333040.o fmapFMAPAM_ROU1000508936.o fmapFMAPSTRFSE258056667.o fmapFMAPdTPCOD1051074108.o generate_amGEN60284023.o get_optionsCOD183550016.o globals.o get_optionsCOD183550016x.o implIMPL_CREAT99472218.o inlineINLINE_I1557365391.o intiINTI1462257232.o layoutCLASS_LA1330944056.o mangleMANGLE1705139666.o mangleNAMESPAC760510184.o o_localOPT_LOC907909712.o o_localOPT_LOC907909712x.o optimizeOPT_CO1177876774.o optimizeOPT_IT1193060919.o parsePARSER311504339.o parsePARSER311504339x.o parsePARSER311504339xx.o parsePARSER311504339xxx.o parsePARSER311504339xxxx.o progPROG_AS_TB824135997.o scanSCANNER1990933774.o side_effectSE_411721069.o strings.o stringsx.o stringsxx.o system.o stmtAM_FORK_ST1674905658.o tpTP_BUILTIN1142074570.o tpTP_ITER145455607.o transTRANS2123847391.o transTRANS2123847391x.o transTRANS2123847391xx.o transTRANS2123847391xxx.o transTRANS2123847391xxxx.o tupTUPAM_CURSO1313579705.o unbox.o unixUNIX1766692.o runtime.o
OTHER  =


../$(CS): LINK_OPTIONS $(OBJ) $(HDR)
	$(CC) $(CFLAGS) -o ../$(CS) $(OBJ) $(OTHER) $(LIBS)

$(OBJ): COMPILE_OPTIONS $(HDR)

runtime.o: ../../System/Common/runtime.c COMPILE_OPTIONS $(HDR)
	$(CC) $(CFLAGS) -c ../../System/Common/runtime.c

=== System/Common/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 3 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Build the standard things used in all platforms

#GC_CFLAGS=-O -DSILENT -DNO_SIGNALS

# Changes needed for Alpha
#CPP= /usr/ucb/cpp -C -P -DALPHA
#GC_CC=cc 

LIBRARY=../../Library
PLIBRARY=../../pLibrary

all:	CONFIG 

TMPFILE=CONFIG.tmp.c

CONFIG: Makefile ../../Makefile CONFIG.proto $(LIBRARY)/Library.config $(LIBRARY)/Base/*.config $(LIBRARY)/Strings/*.config $(LIBRARY)/Containers/*.config $(LIBRARY)/Ext/*.config $(LIBRARY)/IO/*.config $(LIBRARY)/System/*.config Makefile $(PLIBRARY)/pSather/*.config
	@echo Creating Common/CONFIG...
	@echo "-- This file has been created by using cpp on CONFIG.proto" > $(TMPFILE)
	@echo "-- in this directory and by using many variables defined " >> $(TMPFILE)
	@echo "-- in the top level Makefile. Please do not edit it" >> $(TMPFILE)
	@echo "#define CONFIG_DEFAULT_PLATFORM \"$(DEFAULT_PLATFORM)\"" >> $(TMPFILE)
	@echo -n "#define CONFIG_PLATFORMS \"" >> $(TMPFILE)
	@echo -n                           $(PLATFORMS) | sed "s/ //;s/,/\",\"/" >> $(TMPFILE)
	@echo                                                                    "\"" >> $(TMPFILE)
	@echo "#include \"CONFIG.proto\"" >> $(TMPFILE)
	@$(CPP) -undef $(TMPFILE) > CONFIG
	@$(RM) $(TMPFILE)

# The following did not work, because of predefined macros. Unfortunately, I could not find a way to 
# remove predefined macros while still keep the macros defined at the command line
#	@$(CPP) -Uunix -DCONFIG_DEFAULT_PLATFORM='$(DEFAULT_PLATFORM)' -DCONFIG_PLATFORMS='$(PLATFORMS)' CONFIG.proto >> CONFIG

clean:
	$(RM) CONFIG $(TMPFILE)
	cd ActiveThreads; $(MAKE) clean
	cd Brahma; $(MAKE) clean
	cd Siva; $(MAKE) clean

=== System/pSather/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 3 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Toplevel Makefile for pSather

include pSather.options 

CFLAGS=-g -Wall 
MM=$(MAKE) PSATHER='$(PSATHER)'

include Make.config

all:	$(ARCH)

Make.config:
	touch Make.config

linux: dirs
	./bin/mkconfig Make.Linux
	cd lwp ; $(MM) install
	cd am ; $(MM) install
	cd pSather ; $(MM) install

win32: dirs
	./bin/mkconfig Make.Win32
	cd lwp ; $(MM) install
	cd am ; $(MM) install
	cd pSather ; $(MM) install

sun: dirs
	./bin/mkconfig Make.SunOS4
	cd lwp ; $(MM) install
	cd am ; $(MM) install
	cd pSather ; $(MM) install

sun-no-threads: dirs
	@echo "*** This configuration does not work for pSather"
	@echo "*** but is useful for debugging reasons."
	./bin/mkconfig Make.SunOS4-no-threads
	cd lwp ; $(MM) install
	cd am ; $(MM) install

solaris: dirs
	./bin/mkconfig Make.Solaris2.4
#	cd am ; $(MM) install
	cp lib/libam_solaris.a lib/libam.a
	cd pSather ; $(MM) install

solaris-tcpip: dirs
	./bin/mkconfig Make.Solaris2.4-tcpip
#	cd am ; $(MM) install
	cp lib/libam_solaris_tcp.a lib/libam.a
	cd pSather ; $(MM) install

solaris-tcpip-no-threads: dirs
	@echo "*** This configuration does not work for pSather"
	@echo "*** but is useful for debugging reasons."
	./bin/mkconfig Make.Solaris2.4-tcpip-no-threads
	cd am ; $(MM) install ; cd ..

solaris-myrinet: dirs
	./bin/mkconfig Make.Solaris2.4-myrinet
#	$(MM) lcp.dat
#	cd am ; $(MM) install
	cp lib/libam_myrinet.a lib/libam.a
	cd pSather ; $(MM) install

solaris-myrinet-no-threads: dirs
	@echo "*** This configuration does not work for pSather"
	@echo "*** but is useful for debugging reasons."
	./bin/mkconfig Make.Solaris2.4-myrinet-no-threads
#	$(MM) lcp.dat
	cd am ; $(MM) install

solaris-no-threads: dirs
	@echo "*** This configuration does not work for pSather"
	@echo "*** but is useful for debugging reasons."
	./bin/mkconfig Make.Solaris2.4-no-threads
	cd am ; $(MM) install

lcp.dat:
	cd config/lanai/lcp ; sh -c $(COMPILE_LANAI)

meiko: dirs
	./bin/mkconfig Make.Meiko
#	cd am ; $(MM) install
	cp lib/libam_meiko.a lib/libam.a
	cd pSather ; $(MM) install

meiko-no-threads: dirs
	./bin/mkconfig Make.Meiko-no-threads
	cd am ; $(MM) install
	cd pSather ; $(MM) install

# Make a copy of the directory in "DIR". Dir has to be passed
# as an argument. Example:  make DIR=/u/fleiner/pSather/c.code copy
# DIR must already exist. It will create the directory pSather in
# DIR. It assumes that it is running in $SATHER_CONFIG/System/pSather
# 
# To safe time and space, this rule checks first to see if
# the pSather install directory is writable. If so, it will
# only install a link to it. This avoids the copy and possibly 
# recompilation too.

copy:
	@if [ ! -d "${DIR}" ]; then \
		echo "Sorry, ${DIR} does not exist, aborting" ; \
		exit 1 ; \
	fi 
	@if [ -d "${DIR}/pSather" ]; then \
		$(RM) -rf ${DIR}/pSather ; \
	fi
	@if [ -h "${DIR}/pSather" ]; then \
		$(RM) -f ${DIR}/pSather ; \
	fi
	@if [ -w Makefile ]; then \
		ln -sf ${SATHER_HOME}/System/pSather ${DIR}/pSather ; \
		if cmp ${DIR}/sather.h include/sather.h 2>&1 > /dev/null; then :; else touch Makefile; fi; \
		cp ${DIR}/*.h include ; \
	else \
		mkdir ${DIR}/pSather ; \
		mkdir ${DIR}/pSather/am ; \
		mkdir ${DIR}/pSather/lwp ; \
		mkdir ${DIR}/pSather/lib ; \
		mkdir ${DIR}/pSather/include ; \
		mkdir ${DIR}/pSather/pSather ; \
		ln -sf ${SATHER_HOME}/System/pSather/lib/libam_* ${DIR}/pSather/lib ; \
		cp ${SATHER_HOME}/System/pSather/include/am.h ${DIR}/pSather/include ; \
		cp *.options Make.config Makefile ${DIR}/pSather ; \
		cp lwp/*.[ch] lwp/Makefile ${DIR}/pSather/lwp ; \
		cp am/*.[ch] am/Makefile ${DIR}/pSather/am ; \
		cp pSather/*.[ch] pSather/Makefile ${DIR}/pSather/pSather ; \
		ln -sf ${SATHER_HOME}/System/pSather/config ${DIR}/pSather/config ; \
		ln -sf ${SATHER_HOME}/System/pSather/bin ${DIR}/pSather/bin ; \
	fi

dirs:
	[ -d lib ] || mkdir lib
	[ -d include ] || mkdir include

clean:
	rm -rf lib
	rm -rf include
#	rm -f libraries flags
	cd lwp ; $(MM) clean
	cd am ;  $(MM) clean
	cd pSather ;  $(MM) clean

=== System/Common/ActiveThreads/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 3 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

beware:		
	@echo "-----------------------------------------------------------"; 
	@echo "Please, use one of the following targets:"; 
	@echo "sparc-solaris, i386-solaris, axp-osf, hppa-hpux, mips-irix5"; 
	@echo "i386-linux, i386-win32";
	@echo "-----------------------------------------------------------"; 
	@exit 1; 

sparc-solaris:		
	$(MAKE) all ARCH=sparc-solaris

i386-solaris:	
	$(MAKE) all ARCH=i386-solaris

i386-linux:	
	$(MAKE) all ARCH=i386-linux

i386-win32:	
	$(MAKE) all ARCH=i386-win32

hppa-hpux:		
	$(MAKE) all ARCH=hppa-hpux

axp-osf:
	$(MAKE) all ARCH=axp-osf

mips-irix5:
	$(MAKE) all ARCH=mips-irix5

all:		
	$(MAKE) -C src $(ARCH)

tests: all
	$(MAKE) -C tests ARCH=$(ARCH)		

clean:
	rm -f src/*.o 
	rm -f md/*/*.o
	rm -f schedulers/*.o
	rm -rf lib
	$(MAKE) -C tests clean

=== System/Common/Brahma/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 3 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Platforms:
#
#   serial		 - No concurrency
#   smp_solaris          - Threads, emulated clusters (solaris)
#   at_solaris_smp       - Threads, emulated clusters (Active Threads based)
#   tcpip                - TCP/IP AM (solaris)
#   myrinet              - Myrinet AM (solaris)

#   lwp_linux            - Threads, emulated clusters (linux/lwp)
#   smp_lwp              - Threads, emulated clusters (linux/lwp)
#   shmem                - Using shmem AM, for debugging (solaris)
#   meiko                - Meiko AM (solaris)
#
# The Brahma archive file may be created for a given platform "foo" like this:
#
#   make foo INSTALL=xxx.a

#These are used in all platforms
COMMON_DIR = solaris_common
LIB_DIR = library
BENCHMARK_DIR = benchmarks
TEST_DIR = tests
# set to -g for debugging
DEBUG_FLAG = 

###################################

all:
	@echo "There is no default make rule: read the Brahma Makefile."

beware:
	@if [ -z "$(INSTALL)" ]; then \
	   echo "You forgot to set the INSTALL location."; \
	   exit 1; \
	fi

###################################

SERIAL_SRC_DIR = serial
serial: beware $(SERIAL_SRC_DIR)/serial.c \
	       $(SERIAL_SRC_DIR)/serial.h
	gcc -O3 -DBR_SERIAL -c brahma.c
	@echo Creating library $(INSTALL)...
	ar rus $(INSTALL) brahma.o

LWP_LINUX_SRC_DIR = lwp_linux
LWP_DIR = ../../pSather/lwp
lwp_linux: beware $(LWP_LINUX_SRC_DIR)/lwp_linux.c \
		  $(LWP_LINUX_SRC_DIR)/lwp_linux.h
	gcc -O3 -DBR_LWP_LINUX -I$(LWP_DIR) -c brahma.c
	@echo Creating library $(INSTALL)...
	ar rus $(INSTALL) brahma.o

SMP_SRC_DIR = smp_solaris
SMP_INC_DIR = -I. -I$(SMP_SRC_DIR) -I$(COMMON_DIR)
smp_solaris: beware $(SMP_SRC_DIR)/smp_solaris.c \
		    $(SMP_SRC_DIR)/smp_solaris.h \
		    $(COMMON_DIR)/solaris_sync.c \
		    $(COMMON_DIR)/solaris_sync.h \
		    $(COMMON_DIR)/solaris_types.h
	gcc $(DEBUG_FLAG) -O3 -DBR_SMP_SOLARIS $(SMP_INC_DIR) -c brahma.c
	@echo Creating library $(INSTALL)...
	ar rus $(INSTALL) brahma.o 

AT_SOL_SMP_SRC_DIR	= at_solaris_smp
AT_COMMON_DIR		= $(SATHER_HOME)/System/Common/Brahma/at_common  
AT_DIR			= $(SATHER_HOME)/System/Common/ActiveThreads
AT_SRC_DIR		= $(AT_DIR)/src
AT_MD_DIR		= $(AT_DIR)/md/$(ARCH)
AT_COMMON_INC_DIR	= -I$(AT_COMMON_DIR) -I$(AT_DIR)/include -I$(AT_MD_DIR)
AT_SMP_INC_DIR		= -I. -I$(AT_SOL_SMP_SRC_DIR) $(AT_COMMON_INC_DIR)
AT_LIB_DIR         = -L$(AT_DIR)/lib
AT_LIBS            = -lqt -lat -lschedulers
# turn off opt
at_solaris_smp: beware  ${AT_SOL_SMP_SRC_DIR}/at_solaris_smp.c \
			${AT_COMMON_DIR}/at_sync.c \
			${AT_SOL_SMP_SRC_DIR}/at_solaris_smp.h  \
			${AT_COMMON_DIR}/at_sync.h \
			${AT_COMMON_DIR}/at_types.h
	gcc $(DEBUG_FLAG) -O3 -DBR_AT_SOLARIS_SMP $(AT_SMP_INC_DIR) -c brahma.c
	@echo Creating library $(INSTALL)...
	ar rus $(INSTALL) brahma.o 

AT_LINUX_SMP_SRC_DIR   = at_linux_smp
AT_LINUX_SMP_INC_DIR   = -I. -I$(AT_LINUX_SMP_SRC_DIR) $(AT_COMMON_INC_DIR)
at_linux_smp: beware  ${AT_LINUX_SMP_SRC_DIR}/at_linux_smp.c \
                      ${AT_COMMON_DIR}/at_sync.c \
                      ${AT_LINUX_SMP_SRC_DIR}/at_linux_smp.h  \
                      ${AT_COMMON_DIR}/at_sync.h \
                      ${AT_COMMON_DIR}/at_types.h
	gcc $(DEBUG_FLAG) -O3 -DBR_AT_LINUX_SMP $(AT_LINUX_SMP_INC_DIR) -c brahma.c
	@echo Creating library $(INSTALL)...
	ar rus $(INSTALL) brahma.o

AT_WIN32_SMP_SRC_DIR   = at_win32_smp
AT_WIN32_SMP_INC_DIR   = -I. -I$(AT_WIN32_SMP_SRC_DIR) $(AT_COMMON_INC_DIR)
at_win32_smp: beware  ${AT_WIN32_SMP_SRC_DIR}/at_win32_smp.c \
                      ${AT_COMMON_DIR}/at_sync.c \
                      ${AT_WIN32_SMP_SRC_DIR}/at_win32_smp.h  \
                      ${AT_COMMON_DIR}/at_sync.h \
                      ${AT_COMMON_DIR}/at_types.h
	gcc $(DEBUG_FLAG) -O3 -DBR_AT_WIN32_SMP $(AT_WIN32_SMP_INC_DIR) -c brahma.c
	@echo Creating library $(INSTALL)...
	ar rus $(INSTALL) brahma.o
 
#these are simply included
${AT_COMMON_DIR}/at_sync.c:
${AT_SOL_SMP_SRC_DIR}/at_solaris_smp.c:
${AT_COMMON_DIR}/at_sync.h:
${AT_COMMON_DIR}/at_types.h:

OSF_AT_AXP_SMP_SRC_DIR	= osf_at_axp_smp
OSF_AT_AXP_SMP_INC_DIR	= -I. -I$(OSF_AT_AXP_SMP_SRC_DIR) $(AT_COMMON_INC_DIR)
osf_at_axp_smp: beware  ${OSF_AT_AXP_SMP_SRC_DIR}/osf_at_axp_smp.c \
			${AT_COMMON_DIR}/at_sync.c \
			${OSF_AT_AXP_SMP_SRC_DIR}/osf_at_axp_smp.h  \
			${AT_COMMON_DIR}/at_sync.h \
			$(AT_COMMON_DIR)/at_types.h
	gcc $(DEBUG_FLAG) -O3 -DBR_OSF_AT_AXP_SMP $(AT_SMP_INC_DIR) -c brahma.c
	@echo Creating library $(INSTALL)...
	ar rus $(INSTALL) brahma.o 

#these are simply included
${OSF_AT_AXP_SMP_SRC_DIR}/osf_at_axp_smp.c:

HPUX_AT_HPPA_SMP_SRC_DIR = hpux_at_hppa_smp
HPUX_AT_HPPA_SMP_INC_DIR = -I. -I$(HPUX_AT_HPPA_SMP_SRC_DIR) $(AT_COMMON_INC_DIR)
hpux_at_hppa_smp: beware  ${HPUX_AT_HPPA_SMP_SRC_DIR}/hpux_at_hppa_smp.c \
			${AT_COMMON_DIR}/at_sync.c \
			${HPUX_AT_HPPA_SMP_SRC_DIR}/hpux_at_hppa_smp.h  \
			${AT_COMMON_DIR}/at_sync.h \
			$(AT_COMMON_DIR)/at_types.h
	gcc $(DEBUG_FLAG) -O3 -DBR_HPUX_AT_HPPA_SMP $(AT_SMP_INC_DIR) -c brahma.c
	@echo Creating library $(INSTALL)...
	ar rus $(INSTALL) brahma.o 

#these are simply included
${HPUX_AT_HPPA_SMP_SRC_DIR}/hpux_at_hppa_smp.c:

TCP_FLAGS = -Wall -DTCP -DQQ_THREADS -DSOLARIS_THREADS -D_REENTRANT -DBR_TCP_SOLARIS $(DEBUG_FLAG) 
TCP_SRC_DIR = tcp_solaris
TCP_INC_DIR = -I. -I$(TCP_SRC_DIR) -I$(COMMON_DIR)
tcp_solaris: beware $(TCP_SRC_DIR)/tcp_solaris.c \
		    $(TCP_SRC_DIR)/tcp_solaris.h \
		    $(COMMON_DIR)/solaris_sync.c \
		    $(COMMON_DIR)/solaris_sync.h \
		    $(COMMON_DIR)/solaris_types.h \
		    $(LIB_DIR)/br_barrier.c \
		    $(TCP_SRC_DIR)/br_tcpam.c \
		    $(TCP_SRC_DIR)/br_tcpam.h
	gcc $(DEBUG_FLAG) -DBR_TCP_SOLARIS $(TCP_INC_DIR) -c brahma.c -o $(TCP_SRC_DIR)/brahma.o
	gcc $(DEBUG_FLAG) -DBR_TCP_SOLARIS $(TCP_INC_DIR) -c $(LIB_DIR)/br_barrier.c -o $(TCP_SRC_DIR)/br_barrier.o
	gcc -c $(TCP_SRC_DIR)/br_tcpam.c -I. $(TCP_INC_DIR) -Itcp_solaris $(TCP_FLAGS) -o $(TCP_SRC_DIR)/br_tcpam.o
	@echo Creating library $(INSTALL)...
	ar rus $(INSTALL) $(TCP_SRC_DIR)/brahma.o \
			  $(TCP_SRC_DIR)/br_barrier.o \
			  $(TCP_SRC_DIR)/br_tcpam.o 

MYRI_SRC_DIR = myrinet_solaris/src
MYRI_BIN_DIR = myrinet_solaris/bin
MYRI_LIB_DIR = lib
MYRI_HOME = /u/sather/network/myrinet
MYRI_INC_DIRS = -I. -I$(MYRI_SRC_DIR) -I$(MYRI_HOME)/include
MYRI_LIBS = -lLanaiDevice -lbfd -liberty
MYRI_LIB_DIRS = -L$(MYRI_LIB_DIR) -L/usr/ucblib -L${MYRI_HOME}/lib/sparc_solaris
MYRI_FLAGS = -O2 -D_REENTRANT $(DEBUG_FLAG)

solaris_myrinet: beware
	$(MAKE) -C $(MYRI_SRC_DIR) solaris_sparc INSTALL=$(INSTALL) THREAD_FLAGS="-DSOLARIS -DSOLARIS_THREADS -DBR_MYRINET_SOLARIS -D_REENTRANT"

# need at least -O for inilining to work with gcc */
solaris_at_sparc_myrinet: beware
#	$(MAKE) -C $(MYRI_SRC_DIR) solaris_at_sparc INSTALL=$(INSTALL) THREAD_FLAGS="-g -O4 -DSOLARIS -DAT_NO_INLINE -DAT_THREADS -DBR_MYRINET_SOLARIS_AT $(AT_COMMON_INC_DIR) "
	$(MAKE) -C $(MYRI_SRC_DIR) solaris_at_sparc INSTALL=$(INSTALL) THREAD_FLAGS="-O4 -DSOLARIS -DAT_THREADS -DBR_MYRINET_SOLARIS_AT $(AT_COMMON_INC_DIR) "

smp_lwp:
	@echo The smp_lwp Brahma platform is not yet implemented.

shmem:
	@echo The shmem Brahma platform is not yet implemented.

meiko:
	@echo The meiko Brahma platform is not yet implemented.


###################################

smp_solaris.a: $(SMP_SRC_DIR)/smp_solaris.c \
	       $(SMP_SRC_DIR)/smp_solaris.h \
	       $(COMMON_DIR)/solaris_sync.c \
	       $(COMMON_DIR)/solaris_sync.h \
	       $(COMMON_DIR)/solaris_types.h
	$(MAKE) smp_solaris INSTALL=lib/smp_solaris.a

at_solaris_smp.a: $(AT_SOL_SMP_SRC_DIR)/at_solaris_smp.c \
		  $(AT_SOL_SMP_SRC_DIR)/at_solaris_smp.h \
		  $(AT_COMMON_DIR)/at_sync.c \
		  $(AT_COMMON_DIR)/at_sync.h \
		  $(AT_COMMON_DIR)/at_types.h
	$(MAKE) at_solaris_smp INSTALL=lib/at_solaris_smp.a

at_linux_smp.a: $(AT_LINUX_SMP_SRC_DIR)/at_linux_smp.c \
		$(AT_LINUX_SMP_SRC_DIR)/at_linux_smp.h \
		$(AT_COMMON_DIR)/at_sync.c \
		$(AT_COMMON_DIR)/at_sync.h \
		$(AT_COMMON_DIR)/at_types.h
	$(MAKE) at_linux_smp INSTALL=lib/at_linux_smp.a

at_win32_smp.a: $(AT_WIN32_SMP_SRC_DIR)/at_win32_smp.c \
		$(AT_WIN32_SMP_SRC_DIR)/at_win32_smp.h \
		$(AT_COMMON_DIR)/at_sync.c \
		$(AT_COMMON_DIR)/at_sync.h \
		$(AT_COMMON_DIR)/at_types.h
	$(MAKE) at_win32_smp INSTALL=lib/at_win32_smp.a

osf_at_axp_smp.a: $(OSF_AT_AXP_SMP_SRC_DIR)/osf_at_axp_smp.c \
		  $(AT_SOL_SMP_SRC_DIR)/osf_at_axp_smp.h \
		  $(AT_COMMON_DIR)/at_sync.c \
		  $(AT_COMMON_DIR)/at_sync.h \
		  $(AT_COMMON_DIR)/at_types.h
	$(MAKE) osf_at_axp_smp INSTALL=lib/osf_at_axp_smp.a

hpux_at_hppa_smp.a: $(HPUX_AT_HPPA_SMP_SRC_DIR)/hpux_at_hppa_smp.c \
		    $(AT_SOL_SMP_SRC_DIR)/hpux_at_hppa_smp.h \
		    $(AT_COMMON_DIR)/at_sync.c \
		    $(AT_COMMON_DIR)/at_sync.h \
		    $(AT_COMMON_DIR)/at_types.h
	$(MAKE) hpux_at_hppa_smp INSTALL=lib/hpux_at_hppa_smp.a

tcp_solaris.a: $(TCP_SRC_DIR)/tcp_solaris.c \
	       $(TCP_SRC_DIR)/tcp_solaris.h \
	       $(LIB_DIR)/br_barrier.c \
	       $(COMMON_DIR)/solaris_sync.c \
	       $(COMMON_DIR)/solaris_sync.h \
	       $(COMMON_DIR)/solaris_types.h \
	       $(TCP_SRC_DIR)/br_tcpam.c \
	       $(TCP_SRC_DIR)/br_tcpam.h
	$(MAKE) tcp_solaris INSTALL=lib/tcp_solaris.a

solaris_myrinet.a:
	$(MAKE) solaris_myrinet INSTALL=lib/solaris_myrinet.a

solaris_at_sparc_myrinet.a:
	$(MAKE) solaris_at_sparc_myrinet INSTALL=lib/solaris_at_sparc_myrinet.a ARCH=sparc-solaris

###################################

# Don't use -O3 to avoid interprocedual opts...
benchmark_smp: smp_solaris.a $(BENCHMARK_DIR)/benchmark.c 
	gcc -O2 -DBR_SMP_SOLARIS -I. $(BENCHMARK_DIR)/benchmark.c lib/smp_solaris.a -o benchmark_smp

# Don't use -O3 to avoid interprocedual opts...
benchmark_at_solaris_smp: at_solaris_smp.a $(BENCHMARK_DIR)/benchmark.c 
	gcc $(DEBUG_FLAG) -g -DBR_AT_SOLARIS_SMP $(AT_SMP_INC_DIR) $(BENCHMARK_DIR)/benchmark.c lib/at_solaris_smp.a -o benchmark_at_solaris_smp $(AT_LIB_DIR) $(AT_LIBS)

benchmark_tcp: tcp_solaris.a $(BENCHMARK_DIR)/benchmark.c 
	gcc -O2 -DBR_TCP_SOLARIS -I. $(BENCHMARK_DIR)/benchmark.c tcp_solaris.a -o lib/benchmark_tcp

benchmark_myrinet: solaris_myrinet.a $(BENCHMARK_DIR)/benchmark.c 
	gcc $(MYRI_FLAGS) -DSOLARIS_THREADS -DBR_MYRINET_SOLARIS $(MYRI_INC_DIRS) -I$(COMMON_DIR) $(BENCHMARK_DIR)/benchmark.c -o benchmark_myrinet $(MYRI_LIB_DIRS) lib/solaris_myrinet.a $(MYRI_LIBS) 

benchmark_at_sparc_myrinet: solaris_at_sparc_myrinet.a $(BENCHMARK_DIR)/benchmark.c 
	gcc -g -DAT_NO_INLINE -DAT_THREADS -DBR_MYRINET_SOLARIS_AT $(MYRI_INC_DIRS) $(AT_COMMON_INC_DIR) $(BENCHMARK_DIR)/benchmark.c -o benchmark_at_sparc_myrinet $(MYRI_LIB_DIRS) lib/solaris_at_sparc_myrinet.a $(MYRI_LIBS) $(AT_LIB_DIR) $(AT_LIBS) -lkstat -lposix4 

###################################

test_threads_at: myrinet_solaris/tests/test_threads.c
	gcc -O $(DEBUG_FLAG) -DDEBUG -DAT_THREADS -DBR_MYRINET_SOLARIS_AT $(MYRI_INC_DIRS) $(AT_COMMON_INC_DIR) myrinet_solaris/tests/test_threads.c -o test_threads_at  $(MYRI_LIB_DIRS) lib/solaris_at_sparc_myrinet.a $(MYRI_LIBS) $(AT_LIB_DIR) $(AT_LIBS) -lkstat -lposix4 

test_threads: myrinet_solaris/tests/test_threads.c

=== System/Common/Siva/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 3 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Platforms:
#
#   serial_boehm         - Built using Brahma "serial"; uses Boehm collector
#   serial_solaris       - Built using Brahma "serial"; ultrasparc/solaris
#   smp_solaris          - Built using Brahma "smp_solaris"; ultrasparc/solaris
#
# The Siva archive file may be created for a given platform "foo" like this:
#
#   make foo INSTALL=xxx.a

# The location of the Brahma directory
BR=../Brahma

all:
	@echo There is no default make rule: read the Siva Makefile.

beware:
	@if [ -z "$(INSTALL)" ]; then \
	   echo "You forgot to set the INSTALL location."; \
	   exit 1; \
	fi

$(BR)/lib/serial.a:
	@echo Making Brahma library "serial"...
	cd $(BR); $(MAKE) serial INSTALL=lib/serial.a

#This is to get around `ar's inability to repack archive files
BOEHM_OBJ= allchblk.o alloc.o blacklst.o checksums.o dbg_mlc.o dyn_load.o finalize.o headers.o mach_dep.o malloc.o mark.o mark_rts.o misc.o new_hblk.o obj_map.o os_dep.o ptr_chck.o reclaim.o solaris_threads.o stubborn.o typd_mlc.o
SERIAL_BR_OBJ= brahma.o

serial_boehm: beware serial_boehm.c serial_boehm.h $(BR)/lib/serial.a
# $(GC_A)
	gcc -O3 -DBR_SERIAL -I$(BR) -DSI_SERIAL_BOEHM -c siva.c
	@echo Creating library $(INSTALL)...
	ar x $(GC_A)
	ar x $(BR)/lib/serial.a
	ar rus $(INSTALL) siva.o $(BOEHM_OBJ) $(SERIAL_BR_OBJ)
	rm -f $(BOEHM_OBJ) $(SERIAL_BR_OBJ)

#This is to get around `ar's inability to repack archive files
SERIAL_SOLARIS_OBJ= brahma.o

serial_solaris: beware serial_solaris.c serial_solaris.h zones.c zones.h $(BR)/lib/serial.a
	gcc -O3 -DBR_SERIAL -I$(BR) -DSI_SERIAL_SOLARIS -c siva.c
	@echo Creating library $(INSTALL)...
	ar x $(BR)/lib/serial.a
	ar rus $(INSTALL) siva.o $(SERIAL_SOLARIS_OBJ)
	rm -f $(SERIAL_SOLARIS_OBJ)

serial_solaris_hyper: beware serial_solaris_hyper.c serial_solaris_hyper.h zones.c zones.h $(BR)/lib/serial.a
	gcc -O3 -DBR_SERIAL -I$(BR) -DSI_SERIAL_SOLARIS_HYPER -c siva.c
	@echo Creating library $(INSTALL)...
	ar x $(BR)/lib/serial.a
	ar rus $(INSTALL) siva.o $(SERIAL_SOLARIS_OBJ)
	rm -f $(SERIAL_SOLARIS_OBJ)

#This is to get around `ar's inability to repack archive files
# Commented the .so files out as they tend to migrate from version to version
# (In particular, this depends on the correct setting of LD_LIBRARY_PATH)
# and no longer compiles with ICSI's current environment
# Boris Wed Oct 15 22:42:20 PDT 1997
#SMP_SOLARIS_OBJ= brahma.o libthread.so libkstat.so
SMP_SOLARIS_OBJ= brahma.o

$(BR)/lib/smp_solaris.a:
	@echo Making Brahma library "smp_solaris"...
	cd $(BR); $(MAKE) smp_solaris INSTALL=lib/smp_solaris.a

smp_solaris: beware smp_solaris.c smp_solaris.h zones.c zones.h $(BR)/lib/smp_solaris.a
	gcc -O3 -DBR_SMP_SOLARIS -I$(BR) -DSI_SMP_SOLARIS -c siva.c
	@echo Creating library $(INSTALL)...
	ar x $(BR)/lib/smp_solaris.a
	ar rus $(INSTALL) siva.o $(SMP_SOLARIS_OBJ)
	rm -f $(SMP_SOLARIS_OBJ)

SMP_WIN32_OBJ= brahma.o
smp_win32: beware smp_win32.c smp_win32.h zones.c zones.h $(BR)/lib/smp_win32.a
	gcc -O3 -DBR_SMP_WIN32 -I$(BR) -DSI_SMP_WIN32 -c siva.c
	@echo Creating library $(INSTALL)...
	ar x $(BR)/lib/smp_win32.a
	ar rus $(INSTALL) siva.o $(SMP_WIN32_OBJ)
	rm -f $(SMP_WIN32_OBJ)

SMP_LINUX_OBJ= brahma.o
smp_linux: beware smp_linux.c smp_linux.h zones.c zones.h $(BR)/lib/smp_linux.a
	gcc -O3 -DBR_SMP_LINUX -I$(BR) -DSI_SMP_LINUX -c siva.c
	@echo Creating library $(INSTALL)...
	ar x $(BR)/lib/smp_linux.a
	ar rus $(INSTALL) siva.o $(SMP_LINUX_OBJ)
	rm -f $(SMP_LINUX_OBJ)

# Don't use -O3 to avoid interprocedual opts...
benchmark: serial_boehm.a benchmark.c
	gcc -O2 -DBR_SERIAL -I$(BR) -DSI_SERIAL_BOEHM benchmark.c smp_solaris.a -o benchmark

clean:
	rm -f *.a *.o *.so benchmark
	cd $(BR); $(MAKE) clean
#	cd $(BOEHM); $(MAKE) clean

=== System/Platforms/BOOT/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 3 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

all:
clean:
	rm -f header.h

test:

=== System/Platforms/dualgui/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 3 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Generate the server end for the dual process gui
all:	
	$(SATHER_HOME)/Bin/sacomp GuiServer.module -main GUI_SERVER_END -o dual_gui_server -verbose -output_C
clean:
test:

=== System/Platforms/iris-4/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 3 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

all:
clean:
test:
boot:
	ln -sf `pwd`/header.h ../BOOT
	$(MAKE) -C $(SATHER_HOME)/Boot/sacomp.code CC=$(CC)
	rm -f ../BOOT/header.h

=== System/Platforms/unix/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 3 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

all:
clean:
test:
boot:
	ln -sf `pwd`/header.h ../BOOT
	$(MAKE) -C $(SATHER_HOME)/Boot/sacomp.code CC=$(CC)
	rm -f ../BOOT/header.h

=== debian/control ===
Source: sather
Section: devel
Priority: optional
Maintainer: Norbert Nemec <nobbi@gnu.org>
Standards-Version: 2.4.0.0

Package: sather
Architecture: any
Depends: libgc-dev, ${shlibs:Depends}
Suggests: tk4.2-dev
Description: Sather compiler
 Compiler and programming environment for Sather:
 Sather is an object oriented language which designed to be simple,
 efficient, safe, and non-proprietary. It aims to meet the needs of
 modern research groups and to foster the development of a large,
 freely available, high-quality library of efficient well-written
 classes for a wide variety of computational tasks. It was originally
 based on Eiffel but now incorporates ideas and approaches from several
 languages. One way of placing it in the "space of languages" is to say
 that it attempts to be as efficient as C, C++, or Fortran, as elegant
 and safe as Eiffel or CLU, and to support higher-order functions as
 well as Common Lisp, Scheme, or Smalltalk.

Package: sather-lwp
Architecture: any
Depends: sather
Description: pSather - Parallel extensions to the Sather environment
 This is based on LWP, a implementation of user-space threads, which is also
 included in this package.

Package: sather-doc
Architecture: all
Suggests: sather, www-browser, postscript-viewer, info-browser
Description: Documentation for the object oriented language Sather
 HTML, PostScript, Info documentation for the object oriented language
 Sather.

Package: sather-elisp
Architecture: all
Depends: emacsen
Suggests: sather
Description: Emacs mode for editing Sather programs
 Emacs mode for editing Sather programs.

Package: sather-browser
Architecture: any
Depends: sather, c-shell, tclsh, ${shlibs:Depends}
Description: A Tcl/Tk based class browser for Sather.
 A class browser for the OO-language Sather, written in Sather, using the 
 Tcl/Tk toolkit.
